import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class PrimeSearcher extends HttpServlet implements Runnable {

  long lastprime = 0;         // ostatnia znaleziona liczba pierwsza
  Date lastprimeModified = new Date();  // kiedy zostaa znaleziona
  Thread searcher;                   // drugoplanowy wtek szukajcy

  public void init() throws ServletException {
          searcher = new Thread(this);
          searcher.setPriority(Thread.MIN_PRIORITY); // bd dobrym obywatelem
           searcher.start();
   }

     public void run() {
                //                    QTTTBBBMMMTTTOOO    
         long candidate = 1000000000000001L; // kwadrylion jeden

   // Rozpocznij szukanie liczb pierwszych
     while (true) {               // szukaj cay czas
           if (isPrime(candidate)) {
             lastprime = candidate;                   // nowa liczba pierwsza
             lastprimeModified = new Date();  // nowy "czas" liczby pierwszej
    }
    candidate += 2;    // liczby parzyste nie s liczbami pierwszymi

    // Pomidzy potencjalnymi liczbami pierwszymi rb przerw 0.2 sekundy
    // Kolejny sposb aby by dobrym obywatelem w zasobach systemu
   try {
       searcher.sleep(200);
      }
   catch (InterruptedException ignored) {}
   }
 }

 private static boolean isPrime(long candidate) {
   // Sprbuj podzieli t liczb przez wszystkie liczby
   // nieparzyste z przedziau od 3 do jej pierwiastka kwadratowego

   long sqrt  = (long)Math.sqrt (candidate);
   for (long i = 3; i <= sqrt; i += 2) {
     if (candidate % i == 0) return false;  // znajd czynnik
   }

   // jeli jest pierwsza
   return true;
}
    public void doGet(HttpServletRequest  req, HttpServletResponse res)
                                throws ServletException, IOException {

    res.setContentType ("text/plain; charset=ISO-8859-2");
   PrintWriter  out  = res.getWriter();
   if (lastprime == 0) {
  out.println ("Nadal szukam liczb pierwszych...");
}
else{
  out.println("Ostatnia liczba pierwsza zostaa znaleziona " + lastprime);
  out.println(" w " + lastprimeModified);
}
}

public void destroy() {
  searcher.stop(); 
 }
}
